#include "Test.h"
#include "Vektor.h"




/*
* Insgesamt hatten wir 7 Vektoren
Insgesamt hatten wir 0 Vektor-Zuweisungen
Insgesamt hatten wir 6804 Guests
Insgesamt hatten wir 2800 Guest-Zuweisungen
Vorher ohne Move-Semantik waren es
Insgesamt hatten wir 12 Vektoren
Insgesamt hatten wir 4 Vektor-Zuweisungen
Insgesamt hatten wir 10404 Guests
Insgesamt hatten wir 6400 Guest-Zuweisungen
*/
void testPlusHelp() {
   Guest::ResetCounters();
   Vektor::ResetCounters();
   Vektor v1(400);
   const V_BaseType wert1(11);
   v1.Init(wert1);

   Vektor v2(400);
   const V_BaseType wert2(22);
   v2.Init(wert2);

   Vektor result = v1 + v2;
   result = v1 + v2;
   result = v1 + v1;
   result = v2 + v2;
   result = v1 + v2;
}



bool testPlus() {
   testPlusHelp();
   cout << "Insgesamt hatten wir " << Vektor::GetTotalCounter()
      << " Vektoren" << endl;
   cout << "Insgesamt hatten wir " << Vektor::GetTotalCounterAssign()
      << " Vektor-Zuweisungen" << endl;
   cout << "Insgesamt hatten wir " << Guest::GetTotalCounter()
      << " Guests" << endl;
   cout << "Insgesamt hatten wir " << Guest::GetTotalCounterAssign()
      << " Guest-Zuweisungen" << endl;

   return true;
}


/*
Insgesamt hatten wir 5 Vektoren
Insgesamt hatten wir 0 Vektor-Zuweisungen
Insgesamt hatten wir 3205 Guests
Insgesamt hatten wir 1600 Guest-Zuweisungen

Vorher ohne Move-Semantik waren es:
* Insgesamt hatten wir 7 Vektoren
Insgesamt hatten wir 1 Vektor-Zuweisungen
Insgesamt hatten wir 4405 Guests
Insgesamt hatten wir 2800 Guest-Zuweisungen
*/

void testPlusHelp2() {
   cout << "\n";
   Guest::ResetCounters();
   Vektor::ResetCounters();
   Vektor v1(400);
   const V_BaseType wert1(11);
   v1.Init(wert1);

   Vektor v2(400);
   const V_BaseType wert2(22);
   v2.Init(wert2);

   Vektor result(1);
   result = v1 + v1 + v1;
}


bool testPlus2() {
   testPlusHelp2();
   cout << "Insgesamt hatten wir " << Vektor::GetTotalCounter()
      << " Vektoren" << endl;
   cout << "Insgesamt hatten wir " << Vektor::GetTotalCounterAssign()
      << " Vektor-Zuweisungen" << endl;
   cout << "Insgesamt hatten wir " << Guest::GetTotalCounter()
      << " Guests" << endl;
   cout << "Insgesamt hatten wir " << Guest::GetTotalCounterAssign()
      << " Guest-Zuweisungen" << endl;

   return true;
}